#ifndef EQNETWORKTHREAD_H
#define EQNETWORKTHREAD_H

/*!
 *@file EqNetworkThread.h
 *@author hxcan <caihuosheng@gmail.com>
 *@brief 用于网络通信的线程类。
 */

#include "EcPreCompile.h" //QUrl

#include "ExistMessage.pb.h" //exist::ServicePublishMessage::ServiceProtocolType
#include "ExistCpp_global.h"


/*!
 * \brief The EqNetworkThread class 这个类用于进行网络通信。在ExistCpp内部使用。
 */
class EXISTQTSHARED_EXPORT EqNetworkThread:public Poco::Runnable
{
    void readedSocketData(char * buffer,int bufferLength,Poco::Net::SocketAddress sender); //!<信号，读取到了数据。
    void serviceDiscovered(QString serviceName,quint16 servicePort,ServicePublishMessage::ServiceProtocolType serviceProtocolType); //!<信号，发现了服务。

public:
    void castData(string dataToCast); //!<发送数据。
    void run(); //!<运行。
    EqNetworkThread(); //!<默认构造函数。
    void publishService(string LanServiceName, quint16 LanServicePort, exist::ServicePublishMessage::ServiceProtocolType LanServiceProtocolType); //!<发布服务。

private:
    string cachedServiceData; //!<缓存的服务发布数据。
    void castData(string cachedServiceDataToSend,string senderAddresshosttoString,quint16 servicePort); //!<发布数据到指定IP的指定端口。
    void replyServiceProbe(ExistMessage existMessage,string senderAddresshosttoString); //!<回复服务探测数据包。
    void debugWriteDataGram(char * datagram,int datagramLength); //!<输出数据包的内容到文件。
    void processDatagram(char *datagram, int datagramLength, Poco::Net::SocketAddress senderAddress); //!<处理数据包。
    void initializeMemberObjects(); //!<初始化成员对象。
    Poco::Net::MulticastSocket socket; //!<用于组播通信的套接字。
    void readSocketData(); //!<尝试从网络读取数据。
    void connectSignals(); //!<连接信号槽。
    const quint16 MulticastPort=11500; //!<组播组的端口号。
    static EqNetworkThread * theSharedInstance; //!<共享实例。
}; //class EXISTQTSHARED_EXPORT GameInfo:public QObject

#endif // GAMEINFO_H
