#ifndef SERVICEPUBLISHER_H
#define SERVICEPUBLISHER_H

/*!
 *@file ServicePublisher.h
 *@author hxcan <caihuosheng@gmail.com>
 *@brief ExistCpp的主要接口，用于向局域网发布服务。
 */

#include "EcPreCompile.h" //QUrl

#include "ExistMessage.pb.h" //exist::ServicePublishMessage::ServiceProtocolType
#include "EqNetworkThread.h" //EqNetworkThread

/*!
 * \brief The ServicePublisher class 这个类用于向局域网中发布服务。这是ExistCpp的主要接口。
 */
class EXISTQTSHARED_EXPORT ServicePublisher
{
    void shoudCastData(string datagram); //!<信号，应当发送数据。
    void serviceDiscovered(QString serviceName,quint16 servicePort,ServicePublishMessage::ServiceProtocolType serviceProtocolType,string address); //!<信号，发现了服务。

public:
    ServicePublisher(); //!<默认构造函数。
    void publishService(string LanServiceName, quint16 LanServicePort, exist::ServicePublishMessage::ServiceProtocolType LanServiceProtocolType); //!<发布服务。

private:
    Poco::Thread networkPocoThread; //!<网络线程。
    EqNetworkThread networkThread; //!<进行数据发送的对象。
    void reportServiceDiscovered(ExistMessage existMessage, string address); //!<报告，发现了服务。
    void processDatagram(char *datagram, int datagramLength, Poco::Net::SocketAddress senderAddress); //!<处理数据包。
    void listen(); //!<监听。
    const quint16 MulticastPort=16574; //!<组播组的端口号。
    void startNetworkThread(); //!<启动网络线程。
}; //class EXISTQTSHARED_EXPORT GameInfo:public QObject

#endif // GAMEINFO_H
